## orthanc-wsi 0.5

=== Applications/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(OrthancWSIApplications)

include(${CMAKE_SOURCE_DIR}/../Resources/CMake/Version.cmake)


#####################################################################
## Parameters of the build
#####################################################################

# Generic parameters
SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
SET(ENABLE_PROFILING OFF CACHE BOOL "Whether to enable the generation of profiling information with gprof")

# Advanced parameters to fine-tune linking against system libraries
SET(USE_SYSTEM_LIBTIFF ON CACHE BOOL "Use the system version of libtiff")
SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")
SET(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")



#####################################################################
## Configure mandatory third-party components
#####################################################################

SET(ORTHANC_WSI_DIR ${CMAKE_CURRENT_LIST_DIR}/..)
SET(USE_OPENJPEG_JP2 ON)

include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/DownloadOrthancFramework.cmake)

UNSET(STANDALONE_BUILD CACHE)
SET(STANDALONE_BUILD ON)       # Embed DCMTK's dictionaries for static builds

set(ORTHANC_FRAMEWORK_PLUGIN OFF)
include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkParameters.cmake)

SET(ENABLE_CRYPTO_OPTIONS ON)
SET(ENABLE_DCMTK ON)
SET(ENABLE_DCMTK_JPEG OFF)          # Disable DCMTK's support for JPEG, that clashes with libtiff
SET(ENABLE_DCMTK_JPEG_LOSSLESS OFF) # Disable DCMTK's support for JPEG-LS
SET(ENABLE_DCMTK_NETWORKING OFF)    # Disable DCMTK's support for DICOM networking
SET(ENABLE_JPEG ON)
SET(ENABLE_LOCALE ON)               # Enable support for locales (notably in Boost)
SET(ENABLE_PNG ON)
SET(ENABLE_SSL ON)
SET(ENABLE_WEB_CLIENT ON)
SET(ENABLE_ZLIB ON)
SET(HAS_EMBEDDED_RESOURCES ON)

include(${ORTHANC_ROOT}/Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkConfiguration.cmake)
include_directories(${ORTHANC_ROOT})


# Include components specific to WSI
include(${ORTHANC_WSI_DIR}/Resources/CMake/BoostExtendedConfiguration.cmake)
include(${ORTHANC_WSI_DIR}/Resources/CMake/OpenJpegConfiguration.cmake)
include(${ORTHANC_WSI_DIR}/Resources/CMake/LibTiffConfiguration.cmake)



#####################################################################
## Find the Orthanc SDK
#####################################################################

if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
  include_directories(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/Sdk-1.0.0)
else ()
  CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCPlugin.h HAVE_ORTHANC_H)
  if (NOT HAVE_ORTHANC_H)
    message(FATAL_ERROR "Please install the headers of the Orthanc plugins SDK")
  endif()
endif()


#####################################################################
## Create the list of the source files that depend upon the
## precompiled headers
#####################################################################

set(ORTHANC_WSI_SOURCES
  ${ORTHANC_WSI_DIR}/Framework/Algorithms/PyramidReader.cpp
  ${ORTHANC_WSI_DIR}/Framework/Algorithms/ReconstructPyramidCommand.cpp
  ${ORTHANC_WSI_DIR}/Framework/Algorithms/TranscodeTileCommand.cpp
  ${ORTHANC_WSI_DIR}/Framework/DicomToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/DicomizerParameters.cpp
  ${ORTHANC_WSI_DIR}/Framework/Enumerations.cpp
  ${ORTHANC_WSI_DIR}/Framework/ImageToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/ImagedVolumeParameters.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DecodedTiledPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidInstance.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidLevel.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/HierarchicalTiff.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/OpenSlideLibrary.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/OpenSlidePyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/PyramidWithRawTiles.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/SingleLevelDecodedPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/TiledPyramidStatistics.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Reader.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Writer.cpp
  ${ORTHANC_WSI_DIR}/Framework/Targets/FolderTarget.cpp
  ${ORTHANC_WSI_DIR}/Framework/Targets/OrthancTarget.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/DicomPyramidWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/HierarchicalTiffWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/InMemoryTiledImage.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/MultiframeDicomWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/PyramidWriterBase.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/TruncatedPyramidWriter.cpp
  )

EmbedResources(
  ${DCMTK_DICTIONARIES}
  BRIGHTFIELD_OPTICAL_PATH  ${ORTHANC_WSI_DIR}/Resources/BrightfieldOpticalPath.json
  SAMPLE_DATASET            ${ORTHANC_WSI_DIR}/Resources/SampleDataset.json
  SRGB_ICC_PROFILE          ${ORTHANC_WSI_DIR}/Resources/sRGB.icc
  )

add_definitions(
  -DHAS_ORTHANC_EXCEPTION=1
  )


#####################################################################
## Setup precompiled headers for Microsoft Visual Studio
#####################################################################

if (MSVC)
  add_definitions(-DORTHANC_USE_PRECOMPILED_HEADERS=1)

  set(TMP
    ${ORTHANC_CORE_SOURCES_INTERNAL}
    ${ORTHANC_DICOM_SOURCES_INTERNAL}
    )
  
  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeaders.h" "${ORTHANC_ROOT}/Core/PrecompiledHeaders.cpp"
    TMP ORTHANC_CORE_PCH)

  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeadersWSI.h" "${ORTHANC_WSI_DIR}/Framework/PrecompiledHeadersWSI.cpp"
    ORTHANC_WSI_SOURCES ORTHANC_WSI_PCH)

  source_group(ThirdParty\\OrthancCore FILES ${ORTHANC_CORE_SOURCES})
endif()


#####################################################################
## Create the static library containing the framework
#####################################################################

add_library(OrthancWSIFramework STATIC
  ${ORTHANC_CORE_PCH}
  ${ORTHANC_CORE_SOURCES_INTERNAL}
  ${ORTHANC_CORE_SOURCES_DEPENDENCIES}
  ${ORTHANC_DICOM_SOURCES_INTERNAL}
  ${ORTHANC_DICOM_SOURCES_DEPENDENCIES}
  ${ORTHANC_WSI_PCH}
  ${ORTHANC_WSI_SOURCES}
  ${AUTOGENERATED_SOURCES}
  ${BOOST_EXTENDED_SOURCES}

  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginCppWrapper.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomDatasetReader.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomPath.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomTag.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/FullOrthancDataset.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/IOrthancConnection.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancHttpConnection.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginConnection.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/SimplifiedOrthancDataset.cpp

  # Mandatory components
  ${LIBTIFF_SOURCES}
  ${OPENJPEG_SOURCES}
  )


#####################################################################
## Build the WSI DICOM-izer
#####################################################################

# Create the Windows resources, if need be
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_WSI_VERSION} OrthancWSIDicomizer OrthancWSIDicomizer.exe "Companion tool to Orthanc for whole-slide imaging"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/OrthancWSIDicomizer.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(DICOMIZER_RESOURCES ${AUTOGENERATED_DIR}/OrthancWSIDicomizer.rc)
endif()


add_executable(OrthancWSIDicomizer
  Dicomizer.cpp
  ApplicationToolbox.cpp
  ${DICOMIZER_RESOURCES}
  )

target_link_libraries(OrthancWSIDicomizer OrthancWSIFramework ${DCMTK_LIBRARIES})

install(
  TARGETS OrthancWSIDicomizer
  RUNTIME DESTINATION bin
  )


#####################################################################
## Build the DICOM-to-TIFF conversion tool
#####################################################################

# Create the Windows resources, if need be
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_WSI_VERSION} OrthancWSIDicomToTiff OrthancWSIDicomToTiff.exe "Companion tool to Orthanc for whole-slide imaging"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/OrthancWSIDicomToTiff.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(DICOM_TO_TIFF_RESOURCES ${AUTOGENERATED_DIR}/OrthancWSIDicomToTiff.rc)
endif()


add_executable(OrthancWSIDicomToTiff
  DicomToTiff.cpp
  ApplicationToolbox.cpp
  ${DICOM_TO_TIFF_RESOURCES}
  )

target_link_libraries(OrthancWSIDicomToTiff OrthancWSIFramework ${DCMTK_LIBRARIES})

install(
  TARGETS OrthancWSIDicomToTiff
  RUNTIME DESTINATION bin
  )


#####################################################################
## Generate the documentation if Doxygen is present
#####################################################################

find_package(Doxygen)
if (DOXYGEN_FOUND)
  configure_file(
    ${ORTHANC_WSI_DIR}/Resources/OrthancWSI.doxygen
    ${CMAKE_CURRENT_BINARY_DIR}/OrthancWSI.doxygen
    @ONLY)

  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/OrthancWSI.doxygen
    COMMENT "Generating documentation with Doxygen" VERBATIM
    )
else()
  message("Doxygen not found. The documentation will not be built.")
endif()

=== ViewerPlugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(OrthancWSIPlugin)

include(${CMAKE_SOURCE_DIR}/../Resources/CMake/Version.cmake)


#####################################################################
## Parameters of the build
#####################################################################

# Generic parameters
SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")

# Advanced parameters to fine-tune linking against system libraries
SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")
SET(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")

# Parameters related to OpenLayers
SET(USE_SYSTEM_OPENLAYERS OFF CACHE BOOL "Use the system version of OpenLayers")
SET(OPENLAYERS_CSS "" CACHE FILEPATH "Path to the system version of OpenLayers CSS")
SET(OPENLAYERS_JS "" CACHE FILEPATH "Path to the system version of OpenLayers JavaScript")


#####################################################################
## Configure mandatory third-party components
#####################################################################

SET(ORTHANC_WSI_DIR ${CMAKE_CURRENT_LIST_DIR}/..)
SET(USE_OPENJPEG_JP2 ON)

include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/DownloadOrthancFramework.cmake)

set(ORTHANC_FRAMEWORK_PLUGIN ON)
include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkParameters.cmake)

set(ENABLE_LOCALE OFF)         # Disable support for locales (notably in Boost)
set(ENABLE_ZLIB ON)
set(ENABLE_PNG ON)
set(ENABLE_JPEG ON)

include(${ORTHANC_ROOT}/Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkConfiguration.cmake)
include_directories(${ORTHANC_ROOT})

# Include components specific to WSI
include(${ORTHANC_WSI_DIR}/Resources/CMake/Version.cmake)
include(${ORTHANC_WSI_DIR}/Resources/CMake/OpenJpegConfiguration.cmake)


#####################################################################
## Find the Orthanc SDK
#####################################################################

if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
  include_directories(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/Sdk-1.0.0)
else ()
  CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCPlugin.h HAVE_ORTHANC_H)
  if (NOT HAVE_ORTHANC_H)
    message(FATAL_ERROR "Please install the headers of the Orthanc plugins SDK")
  endif()
endif()


#####################################################################
## Platform-specific configuration
#####################################################################

add_definitions(
  -DHAS_ORTHANC_EXCEPTION=1
  )

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" OR
    ${CMAKE_SYSTEM_NAME} STREQUAL "kFreeBSD" OR
    ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  link_libraries(rt)

elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_WSI_VERSION} "OrthancWSI" OrthancWSI.dll "Whole-slide imaging plugin for Orthanc"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/Version.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  list(APPEND AUTOGENERATED_SOURCES  ${AUTOGENERATED_DIR}/Version.rc)
endif()

if (APPLE)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework CoreFoundation")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -framework CoreFoundation")
endif()


#####################################################################
## Prepare OpenLayers
#####################################################################

if (STATIC_BUILD OR NOT USE_SYSTEM_OPENLAYERS)
  DownloadPackage(
    "77e57aad873c2d4deea8bb1446e9b87a"
    "http://www.orthanc-server.com/downloads/third-party/WSI/openlayers-3.19.0-dist.zip"
    "v3.19.0-dist")
  
  set(OPENLAYERS_RESOURCES
    OPENLAYERS_CSS  ${CMAKE_CURRENT_BINARY_DIR}/v3.19.0-dist/ol.css
    OPENLAYERS_JS   ${CMAKE_CURRENT_BINARY_DIR}/v3.19.0-dist/ol.js
    )

else()
  if (OPENLAYERS_CSS STREQUAL "")
    message(FATAL_ERROR "The option OPENLAYERS_CSS is not set")
  endif()

  if (OPENLAYERS_JS STREQUAL "")
    message(FATAL_ERROR "The option OPENLAYERS_JS is not set")
  endif()

  set(OPENLAYERS_RESOURCES
    OPENLAYERS_CSS  ${OPENLAYERS_CSS}
    OPENLAYERS_JS   ${OPENLAYERS_JS}
    )  
endif()

EmbedResources(
  ${OPENLAYERS_RESOURCES}
  ORTHANC_EXPLORER  ${CMAKE_SOURCE_DIR}/OrthancExplorer.js
  VIEWER_HTML       ${CMAKE_SOURCE_DIR}/viewer.html
  VIEWER_JS         ${CMAKE_SOURCE_DIR}/viewer.js
  )


#####################################################################
## Create the list of the source files that depend upon the
## precompiled headers
#####################################################################

set(ORTHANC_WSI_SOURCES
  DicomPyramidCache.cpp
  Plugin.cpp

  ${ORTHANC_WSI_DIR}/Framework/DicomToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/Enumerations.cpp
  ${ORTHANC_WSI_DIR}/Framework/ImageToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidInstance.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidLevel.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/PyramidWithRawTiles.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Reader.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Writer.cpp

  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomDatasetReader.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomPath.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/FullOrthancDataset.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/IOrthancConnection.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginConnection.cpp
  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginCppWrapper.cpp
  )


#####################################################################
## Setup precompiled headers for Microsoft Visual Studio
#####################################################################

if (MSVC)
  add_definitions(-DORTHANC_USE_PRECOMPILED_HEADERS=1)

  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeaders.h" "${ORTHANC_ROOT}/Core/PrecompiledHeaders.cpp"
    ORTHANC_CORE_SOURCES_INTERNAL ORTHANC_CORE_PCH)

  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeadersWSI.h" "${ORTHANC_WSI_DIR}/Framework/PrecompiledHeadersWSI.cpp"
    ORTHANC_WSI_SOURCES ORTHANC_WSI_PCH)

  source_group(ThirdParty\\OrthancCore FILES ${ORTHANC_CORE_SOURCES})
endif()


#####################################################################
## Create the plugin
#####################################################################

add_library(OrthancWSI SHARED
  ${ORTHANC_CORE_PCH}
  ${ORTHANC_CORE_SOURCES_INTERNAL}
  ${ORTHANC_CORE_SOURCES_DEPENDENCIES}
  ${ORTHANC_WSI_PCH}
  ${ORTHANC_WSI_SOURCES}
  ${AUTOGENERATED_SOURCES}
  ${OPENJPEG_SOURCES}
  )

message("Setting the version of the library to ${ORTHANC_WSI_VERSION}")
set_target_properties(OrthancWSI PROPERTIES 
  VERSION ${ORTHANC_WSI_VERSION} 
  SOVERSION ${ORTHANC_WSI_VERSION})

install(
  TARGETS OrthancWSI
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )

=== debian/changelog ===
orthanc-wsi (0.5-2build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:50:23 +0000

orthanc-wsi (0.5-2) unstable; urgency=medium

  * Set -DNDEBUG to disable assertion checking

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 27 Apr 2018 14:23:59 +0200

orthanc-wsi (0.5-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 24 Apr 2018 11:38:56 +0200

=== debian/control ===
Source: orthanc-wsi
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-all-dev,
               libcurl4-openssl-dev | libcurl4-dev,
               libdcmtk-dev,
               libjpeg-dev,
               libjsoncpp-dev,
               libopenjp2-7-dev,
               libpng-dev,
               libtiff5-dev,
               orthanc-dev (>= 1.1.0),
               uuid-dev,
               yui-compressor,
               zlib1g-dev
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/med-team/orthanc-wsi
Vcs-Git: https://salsa.debian.org/med-team/orthanc-wsi.git
Homepage: http://www.orthanc-server.com/static.php?page=wsi

Package: orthanc-wsi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: orthanc (>= 1.1.0),
            libopenslide0
Description: Whole-slide imaging support for Orthanc (digital pathology)
 Orthanc-WSI brings support of whole-slide imaging for digital
 pathology into Orthanc, the lightweight, RESTful Vendor Neutral
 Archive for medical imaging.
 .
 This package contains two command-line tools to convert whole-slide
 images to and from DICOM. Support for proprietary file formats is
 available through OpenSlide. The package also contains an Orthanc
 plugin to display such DICOM images by any standard Web browser. The
 implementation follows DICOM Supplement 145.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '-' -f 1)
export VIEWER_TARGET := libOrthancWSI.so
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Disable assert() checking from upstream project, for best performance
# https://lists.debian.org/debian-med/2018/04/msg00132.html
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ --parallel

CMAKE_APPLICATIONS_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515

CMAKE_VIEWER_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.min.css \
	-DOPENLAYERS_JS=$(CURDIR)/BuildViewer/ol.min.js \
	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515

override_dh_auto_configure:
        # Put 3rd party packages where the cmake build system expects them
	mkdir -p Applications/ThirdPartyDownloads
	( cd Applications/ThirdPartyDownloads && \
	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.3.2.tar.gz . )

	mkdir -p ViewerPlugin/ThirdPartyDownloads
	( cd ViewerPlugin/ThirdPartyDownloads && \
	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.3.2.tar.gz . )

        # Configure the command-line tools
	mkdir BuildApplications
	dh_auto_configure --builddirectory=BuildApplications \
			  --sourcedirectory=Applications \
			  -- $(CMAKE_APPLICATIONS_EXTRA_FLAGS)

        # Minify the official OpenLayers 3.19.0 distribution (Debian
        # packages only contains OpenLayers 2 for the time being,
        # which is incompatible with OpenLayers 3)
	mkdir -p BuildViewer
	yui-compressor debian/JS/openlayers-3.19.0/ol-debug.js > BuildViewer/ol.min.js
	yui-compressor debian/JS/openlayers-3.19.0/ol.css > BuildViewer/ol.min.css

        # Configure the Web viewer plugin
	dh_auto_configure --builddirectory=BuildViewer \
			  --sourcedirectory=ViewerPlugin \
			  -- $(CMAKE_VIEWER_EXTRA_FLAGS)

override_dh_auto_build:
        # Build the command-line tools
	dh_auto_build --builddirectory=BuildApplications \
		      --sourcedirectory=Applications

        # Build the Web viewer plugin
	dh_auto_build --builddirectory=BuildViewer \
		      --sourcedirectory=ViewerPlugin

override_dh_clean:
	rm -rf Applications/ThirdPartyDownloads/
	rm -rf ViewerPlugin/ThirdPartyDownloads/

	dh_clean

override_dh_auto_install:
        # Install the command-line tools
	dh_auto_install --builddirectory=BuildApplications

        # Install the plugin
	cp BuildViewer/${VIEWER_TARGET} BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION}
	dh_install BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION} usr/lib

override_dh_link:
	dh_link usr/lib/${VIEWER_TARGET}.${UPSTREAM_VERSION} \
		usr/share/orthanc/plugins/${VIEWER_TARGET}

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

## orthanc-wsi 0.6

=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -100,14 +100,15 @@
   ${ORTHANC_WSI_DIR}/Framework/Inputs/TiledPyramidStatistics.cpp
   ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Reader.cpp
   ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Writer.cpp
-  ${ORTHANC_WSI_DIR}/Framework/Targets/FolderTarget.cpp
-  ${ORTHANC_WSI_DIR}/Framework/Targets/OrthancTarget.cpp
+  ${ORTHANC_WSI_DIR}/Framework/MultiThreading/BagOfTasksProcessor.cpp
   ${ORTHANC_WSI_DIR}/Framework/Outputs/DicomPyramidWriter.cpp
   ${ORTHANC_WSI_DIR}/Framework/Outputs/HierarchicalTiffWriter.cpp
   ${ORTHANC_WSI_DIR}/Framework/Outputs/InMemoryTiledImage.cpp
   ${ORTHANC_WSI_DIR}/Framework/Outputs/MultiframeDicomWriter.cpp
   ${ORTHANC_WSI_DIR}/Framework/Outputs/PyramidWriterBase.cpp
   ${ORTHANC_WSI_DIR}/Framework/Outputs/TruncatedPyramidWriter.cpp
+  ${ORTHANC_WSI_DIR}/Framework/Targets/FolderTarget.cpp
+  ${ORTHANC_WSI_DIR}/Framework/Targets/OrthancTarget.cpp
   )
 
 EmbedResources(
@@ -119,6 +120,7 @@
 
 add_definitions(
   -DHAS_ORTHANC_EXCEPTION=1
+  -DORTHANC_ENABLE_LOGGING_PLUGIN=0
   )

=== ViewerPlugin/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,7 @@
 
 add_definitions(
   -DHAS_ORTHANC_EXCEPTION=1
+  -DORTHANC_ENABLE_LOGGING_PLUGIN=1
   )
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" OR
@@ -104,7 +105,7 @@
 if (STATIC_BUILD OR NOT USE_SYSTEM_OPENLAYERS)
   DownloadPackage(
     "77e57aad873c2d4deea8bb1446e9b87a"
-    "http://www.orthanc-server.com/downloads/third-party/WSI/openlayers-3.19.0-dist.zip"
+    "http://orthanc.osimis.io/ThirdPartyDownloads/openlayers-3.19.0-dist.zip"
     "v3.19.0-dist")
   
   set(OPENLAYERS_RESOURCES

=== debian/changelog ===
orthanc-wsi (0.6-2ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:55:09 +0100

orthanc-wsi (0.6-2ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:22:32 +0100

orthanc-wsi (0.6-2ubuntu3) focal; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 19:04:02 +0000

orthanc-wsi (0.6-2ubuntu2) focal; urgency=medium

  * Use orthanc from the archive, rather than included copy of code.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 09 Feb 2020 07:18:14 +0000

orthanc-wsi (0.6-2build2) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 02 Feb 2020 20:24:34 +0100

orthanc-wsi (0.6-2build1) eoan; urgency=medium

  * No change rebuild against new boost regex icu encoded abi ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 08 May 2019 18:10:10 +0100

orthanc-wsi (0.6-2) unstable; urgency=medium

  * Removed $(DEB_VERSION) from SOVERSION.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 28 Jan 2019 13:40:33 +0100

orthanc-wsi (0.6-1) unstable; urgency=medium

  * New upstream version
  * Updated d/upstream/metadata with new reference paper about Orthanc
  * Fix FTBFS with dcmtk 3.6.4, Closes: #919742

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 26 Jan 2019 14:18:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,14 @@
 Source: orthanc-wsi
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 9),
+               devscripts,
+               curl,
                libboost-all-dev,
                libcurl4-openssl-dev | libcurl4-dev,
                libdcmtk-dev,
@@ -18,7 +21,7 @@
                uuid-dev,
                yui-compressor,
                zlib1g-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-wsi
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-wsi.git
 Homepage: http://www.orthanc-server.com/static.php?page=wsi

=== debian/rules ===
--- 
+++ 
@@ -10,15 +10,22 @@
 # https://lists.debian.org/debian-med/2018/04/msg00132.html
 export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+MIRROR=$(shell sed -n 's|.* \(http://[a-z./]*\) .*|\1|p' /etc/apt/sources.list | head -n1)
+FILENAME=$(shell apt-cache show orthanc | grep Filename | cut -d\  -f2 | head -n1 | sed 's|_[a-z0-9]*.deb|.dsc|')
+
 
 %:
 	dh $@ --parallel
 
 CMAKE_APPLICATIONS_EXTRA_FLAGS += \
+	-DORTHANC_FRAMEWORK_SOURCE=path \
+	-DORTHANC_FRAMEWORK_ROOT=$(CURDIR)/Applications/ThirdPartyDownloads/orthanc \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
 
 CMAKE_VIEWER_EXTRA_FLAGS += \
+	-DORTHANC_FRAMEWORK_SOURCE=path \
+	-DORTHANC_FRAMEWORK_ROOT=$(CURDIR)/ViewerPlugin/ThirdPartyDownloads/orthanc \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
 	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.min.css \
@@ -29,11 +36,11 @@
         # Put 3rd party packages where the cmake build system expects them
 	mkdir -p Applications/ThirdPartyDownloads
 	( cd Applications/ThirdPartyDownloads && \
-	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.3.2.tar.gz . )
+	apt-get source orthanc || HOME=$(CURDIR)/Applications/ThirdPartyDownloads dget --allow-unauthenticated $(MIRROR)/$(FILENAME) ; mv orthanc-* orthanc )
 
 	mkdir -p ViewerPlugin/ThirdPartyDownloads
 	( cd ViewerPlugin/ThirdPartyDownloads && \
-	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.3.2.tar.gz . )
+	apt-get source orthanc || HOME=$(CURDIR)/ViewerPlugin/ThirdPartyDownloads dget --allow-unauthenticated $(MIRROR)/$(FILENAME) ; mv orthanc-* orthanc )
 
         # Configure the command-line tools
 	mkdir BuildApplications
@@ -73,11 +80,10 @@
 	dh_auto_install --builddirectory=BuildApplications
 
         # Install the plugin
-	cp BuildViewer/${VIEWER_TARGET} BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION}
-	dh_install BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION} usr/lib
+	dh_install BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION} usr/lib/orthanc
 
 override_dh_link:
-	dh_link usr/lib/${VIEWER_TARGET}.${UPSTREAM_VERSION} \
+	dh_link usr/lib/orthanc/${VIEWER_TARGET}.${UPSTREAM_VERSION} \
 		usr/share/orthanc/plugins/${VIEWER_TARGET}
 
 override_dh_installchangelogs:

## orthanc-wsi 0.7

=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,7 @@
 SET(ENABLE_DCMTK_NETWORKING OFF)    # Disable DCMTK's support for DICOM networking
 SET(ENABLE_JPEG ON)
 SET(ENABLE_LOCALE ON)               # Enable support for locales (notably in Boost)
+SET(ENABLE_OPENSSL_ENGINES ON)
 SET(ENABLE_PNG ON)
 SET(ENABLE_SSL ON)
 SET(ENABLE_WEB_CLIENT ON)

=== ViewerPlugin/CMakeLists.txt ===
--- 
+++ 
@@ -157,6 +157,7 @@
 
   ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomDatasetReader.cpp
   ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomPath.cpp
+  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomTag.cpp
   ${ORTHANC_ROOT}/Plugins/Samples/Common/FullOrthancDataset.cpp
   ${ORTHANC_ROOT}/Plugins/Samples/Common/IOrthancConnection.cpp
   ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginConnection.cpp

=== debian/changelog ===
orthanc-wsi (0.7-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 27 May 2020 17:11:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,11 @@
 Source: orthanc-wsi
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 9),
-               devscripts,
-               curl,
+               debhelper (>= 10),
                libboost-all-dev,
                libcurl4-openssl-dev | libcurl4-dev,
                libdcmtk-dev,
@@ -21,7 +18,7 @@
                uuid-dev,
                yui-compressor,
                zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-wsi
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-wsi.git
 Homepage: http://www.orthanc-server.com/static.php?page=wsi

=== debian/rules ===
--- 
+++ 
@@ -10,22 +10,15 @@
 # https://lists.debian.org/debian-med/2018/04/msg00132.html
 export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
-MIRROR=$(shell sed -n 's|.* \(http://[a-z./]*\) .*|\1|p' /etc/apt/sources.list | head -n1)
-FILENAME=$(shell apt-cache show orthanc | grep Filename | cut -d\  -f2 | head -n1 | sed 's|_[a-z0-9]*.deb|.dsc|')
-
 
 %:
-	dh $@ --parallel
+	dh $@
 
 CMAKE_APPLICATIONS_EXTRA_FLAGS += \
-	-DORTHANC_FRAMEWORK_SOURCE=path \
-	-DORTHANC_FRAMEWORK_ROOT=$(CURDIR)/Applications/ThirdPartyDownloads/orthanc \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
 
 CMAKE_VIEWER_EXTRA_FLAGS += \
-	-DORTHANC_FRAMEWORK_SOURCE=path \
-	-DORTHANC_FRAMEWORK_ROOT=$(CURDIR)/ViewerPlugin/ThirdPartyDownloads/orthanc \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
 	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.min.css \
@@ -36,11 +29,11 @@
         # Put 3rd party packages where the cmake build system expects them
 	mkdir -p Applications/ThirdPartyDownloads
 	( cd Applications/ThirdPartyDownloads && \
-	apt-get source orthanc || HOME=$(CURDIR)/Applications/ThirdPartyDownloads dget --allow-unauthenticated $(MIRROR)/$(FILENAME) ; mv orthanc-* orthanc )
+	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.7.0.tar.gz . )
 
 	mkdir -p ViewerPlugin/ThirdPartyDownloads
 	( cd ViewerPlugin/ThirdPartyDownloads && \
-	apt-get source orthanc || HOME=$(CURDIR)/ViewerPlugin/ThirdPartyDownloads dget --allow-unauthenticated $(MIRROR)/$(FILENAME) ; mv orthanc-* orthanc )
+	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.7.0.tar.gz . )
 
         # Configure the command-line tools
 	mkdir BuildApplications

## orthanc-wsi 1.0

=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,6 @@
 # Advanced parameters to fine-tune linking against system libraries
 SET(USE_SYSTEM_LIBTIFF ON CACHE BOOL "Use the system version of libtiff")
 SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")
-SET(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
 
 
 
@@ -27,52 +26,47 @@
 SET(ORTHANC_WSI_DIR ${CMAKE_CURRENT_LIST_DIR}/..)
 SET(USE_OPENJPEG_JP2 ON)
 
-include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/DownloadOrthancFramework.cmake)
-
-UNSET(STANDALONE_BUILD CACHE)
-SET(STANDALONE_BUILD ON)       # Embed DCMTK's dictionaries for static builds
-
-set(ORTHANC_FRAMEWORK_PLUGIN OFF)
-include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkParameters.cmake)
-
-SET(ENABLE_CRYPTO_OPTIONS ON)
-SET(ENABLE_DCMTK ON)
-SET(ENABLE_DCMTK_JPEG OFF)          # Disable DCMTK's support for JPEG, that clashes with libtiff
-SET(ENABLE_DCMTK_JPEG_LOSSLESS OFF) # Disable DCMTK's support for JPEG-LS
-SET(ENABLE_DCMTK_NETWORKING OFF)    # Disable DCMTK's support for DICOM networking
-SET(ENABLE_JPEG ON)
-SET(ENABLE_LOCALE ON)               # Enable support for locales (notably in Boost)
-SET(ENABLE_OPENSSL_ENGINES ON)
-SET(ENABLE_PNG ON)
-SET(ENABLE_SSL ON)
-SET(ENABLE_WEB_CLIENT ON)
-SET(ENABLE_ZLIB ON)
-SET(HAS_EMBEDDED_RESOURCES ON)
-
-include(${ORTHANC_ROOT}/Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
-include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkConfiguration.cmake)
-include_directories(${ORTHANC_ROOT})
+if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
+  set(ENABLE_DCMTK ON)
+  set(ORTHANC_BOOST_COMPONENTS program_options)
+  include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)  
+
+  link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
+  include_directories(${ORTHANC_FRAMEWORK_ROOT})
+  
+else()
+  include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)
+  include_directories(${ORTHANC_FRAMEWORK_ROOT})
+
+  UNSET(STANDALONE_BUILD CACHE)
+  SET(STANDALONE_BUILD ON)       # Embed DCMTK's dictionaries for static builds
+
+  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)
+
+  SET(ENABLE_CRYPTO_OPTIONS ON)
+  SET(ENABLE_DCMTK ON)
+  SET(ENABLE_DCMTK_JPEG OFF)          # Disable DCMTK's support for JPEG, that clashes with libtiff
+  SET(ENABLE_DCMTK_JPEG_LOSSLESS OFF) # Disable DCMTK's support for JPEG-LS
+  SET(ENABLE_DCMTK_NETWORKING OFF)    # Disable DCMTK's support for DICOM networking
+  SET(ENABLE_JPEG ON)
+  SET(ENABLE_LOCALE ON)               # Enable support for locales (notably in Boost)
+  SET(ENABLE_OPENSSL_ENGINES ON)
+  SET(ENABLE_PNG ON)
+  SET(ENABLE_SSL ON)
+  SET(ENABLE_WEB_CLIENT ON)
+  SET(ENABLE_ZLIB ON)
+
+  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
+  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
+
+  include(${ORTHANC_WSI_DIR}/Resources/CMake/BoostExtendedConfiguration.cmake)
+endif()
 
 
 # Include components specific to WSI
-include(${ORTHANC_WSI_DIR}/Resources/CMake/BoostExtendedConfiguration.cmake)
 include(${ORTHANC_WSI_DIR}/Resources/CMake/OpenJpegConfiguration.cmake)
 include(${ORTHANC_WSI_DIR}/Resources/CMake/LibTiffConfiguration.cmake)
 
-
-
-#####################################################################
-## Find the Orthanc SDK
-#####################################################################
-
-if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
-  include_directories(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/Sdk-1.0.0)
-else ()
-  CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCPlugin.h HAVE_ORTHANC_H)
-  if (NOT HAVE_ORTHANC_H)
-    message(FATAL_ERROR "Please install the headers of the Orthanc plugins SDK")
-  endif()
-endif()
 
 
 #####################################################################
@@ -120,7 +114,6 @@
   )
 
 add_definitions(
-  -DHAS_ORTHANC_EXCEPTION=1
   -DORTHANC_ENABLE_LOGGING_PLUGIN=0
   )
 
@@ -138,7 +131,7 @@
     )
   
   ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
-    "PrecompiledHeaders.h" "${ORTHANC_ROOT}/Core/PrecompiledHeaders.cpp"
+    "PrecompiledHeaders.h" "${ORTHANC_FRAMEWORK_ROOT}/PrecompiledHeaders.cpp"
     TMP ORTHANC_CORE_PCH)
 
   ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
@@ -154,25 +147,22 @@
 #####################################################################
 
 add_library(OrthancWSIFramework STATIC
+  ${ORTHANC_WSI_PCH}
+  ${ORTHANC_WSI_SOURCES}
+
   ${ORTHANC_CORE_PCH}
   ${ORTHANC_CORE_SOURCES_INTERNAL}
   ${ORTHANC_CORE_SOURCES_DEPENDENCIES}
   ${ORTHANC_DICOM_SOURCES_INTERNAL}
   ${ORTHANC_DICOM_SOURCES_DEPENDENCIES}
-  ${ORTHANC_WSI_PCH}
-  ${ORTHANC_WSI_SOURCES}
   ${AUTOGENERATED_SOURCES}
   ${BOOST_EXTENDED_SOURCES}
 
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginCppWrapper.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomDatasetReader.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomPath.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomTag.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/FullOrthancDataset.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/IOrthancConnection.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancHttpConnection.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginConnection.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/SimplifiedOrthancDataset.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/DicomDatasetReader.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/DicomPath.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/FullOrthancDataset.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/IOrthancConnection.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/OrthancHttpConnection.cpp
 
   # Mandatory components
   ${LIBTIFF_SOURCES}
@@ -188,7 +178,7 @@
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
   execute_process(
     COMMAND 
-    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
+    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
     ${ORTHANC_WSI_VERSION} OrthancWSIDicomizer OrthancWSIDicomizer.exe "Companion tool to Orthanc for whole-slide imaging"
     ERROR_VARIABLE Failure
     OUTPUT_FILE ${AUTOGENERATED_DIR}/OrthancWSIDicomizer.rc
@@ -224,7 +214,7 @@
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
   execute_process(
     COMMAND 
-    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
+    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
     ${ORTHANC_WSI_VERSION} OrthancWSIDicomToTiff OrthancWSIDicomToTiff.exe "Companion tool to Orthanc for whole-slide imaging"
     ERROR_VARIABLE Failure
     OUTPUT_FILE ${AUTOGENERATED_DIR}/OrthancWSIDicomToTiff.rc

=== ViewerPlugin/CMakeLists.txt ===
--- 
+++ 
@@ -29,19 +29,29 @@
 SET(ORTHANC_WSI_DIR ${CMAKE_CURRENT_LIST_DIR}/..)
 SET(USE_OPENJPEG_JP2 ON)
 
-include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/DownloadOrthancFramework.cmake)
-
-set(ORTHANC_FRAMEWORK_PLUGIN ON)
-include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkParameters.cmake)
-
-set(ENABLE_LOCALE OFF)         # Disable support for locales (notably in Boost)
-set(ENABLE_ZLIB ON)
-set(ENABLE_PNG ON)
-set(ENABLE_JPEG ON)
-
-include(${ORTHANC_ROOT}/Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
-include(${ORTHANC_ROOT}/Resources/CMake/OrthancFrameworkConfiguration.cmake)
-include_directories(${ORTHANC_ROOT})
+if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
+  set(ENABLE_DCMTK ON)
+  include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)
+
+  include_directories(${ORTHANC_FRAMEWORK_ROOT})
+  link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
+  
+else()
+  include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)
+  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)
+
+  set(ENABLE_LOCALE OFF)         # Disable support for locales (notably in Boost)
+  set(ENABLE_ZLIB ON)
+  set(ENABLE_PNG ON)
+  set(ENABLE_JPEG ON)
+
+  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
+  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)
+
+  include_directories(${ORTHANC_FRAMEWORK_ROOT})
+endif()
+
+include(${ORTHANC_WSI_DIR}/Resources/Orthanc/Plugins/OrthancPluginsExports.cmake)
 
 # Include components specific to WSI
 include(${ORTHANC_WSI_DIR}/Resources/CMake/Version.cmake)
@@ -69,6 +79,7 @@
 add_definitions(
   -DHAS_ORTHANC_EXCEPTION=1
   -DORTHANC_ENABLE_LOGGING_PLUGIN=1
+  -DORTHANC_FRAMEWORK_BUILDING_PLUGIN=1
   )
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" OR
@@ -79,7 +90,7 @@
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
   execute_process(
     COMMAND 
-    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
+    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
     ${ORTHANC_WSI_VERSION} "OrthancWSI" OrthancWSI.dll "Whole-slide imaging plugin for Orthanc"
     ERROR_VARIABLE Failure
     OUTPUT_FILE ${AUTOGENERATED_DIR}/Version.rc
@@ -143,6 +154,7 @@
 
 set(ORTHANC_WSI_SOURCES
   DicomPyramidCache.cpp
+  OrthancPluginConnection.cpp
   Plugin.cpp
 
   ${ORTHANC_WSI_DIR}/Framework/DicomToolbox.cpp
@@ -155,13 +167,11 @@
   ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Reader.cpp
   ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Writer.cpp
 
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomDatasetReader.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomPath.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/DicomTag.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/FullOrthancDataset.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/IOrthancConnection.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginConnection.cpp
-  ${ORTHANC_ROOT}/Plugins/Samples/Common/OrthancPluginCppWrapper.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/DicomDatasetReader.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/DicomPath.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/FullOrthancDataset.cpp
+  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/IOrthancConnection.cpp
   )
 
 
@@ -173,7 +183,7 @@
   add_definitions(-DORTHANC_USE_PRECOMPILED_HEADERS=1)
 
   ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
-    "PrecompiledHeaders.h" "${ORTHANC_ROOT}/Core/PrecompiledHeaders.cpp"
+    "PrecompiledHeaders.h" "${ORTHANC_FRAMEWORK_ROOT}/PrecompiledHeaders.cpp"
     ORTHANC_CORE_SOURCES_INTERNAL ORTHANC_CORE_PCH)
 
   ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
@@ -189,11 +199,11 @@
 #####################################################################
 
 add_library(OrthancWSI SHARED
+  ${ORTHANC_WSI_PCH}
+  ${ORTHANC_WSI_SOURCES}
   ${ORTHANC_CORE_PCH}
   ${ORTHANC_CORE_SOURCES_INTERNAL}
   ${ORTHANC_CORE_SOURCES_DEPENDENCIES}
-  ${ORTHANC_WSI_PCH}
-  ${ORTHANC_WSI_SOURCES}
   ${AUTOGENERATED_SOURCES}
   ${OPENJPEG_SOURCES}
   )

=== debian/changelog ===
orthanc-wsi (1.0-3) unstable; urgency=medium

  * Added missing "Built-Using" attribute. Closes: #989126

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 07 Jun 2021 14:34:06 +0200

orthanc-wsi (1.0-2) unstable; urgency=medium

  * Statically link against the Orthanc framework

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 26 Feb 2021 16:01:23 +0100

orthanc-wsi (1.0-1) unstable; urgency=medium

  * New upstream version
  * Dynamic linking against "liborthancframework*"

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 14 Jan 2021 11:04:29 +0100

=== debian/control ===
--- 
+++ 
@@ -6,19 +6,16 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 10),
-               libboost-all-dev,
                libcurl4-openssl-dev | libcurl4-dev,
                libdcmtk-dev,
-               libjpeg-dev,
-               libjsoncpp-dev,
                libopenjp2-7-dev,
-               libpng-dev,
+               liborthancframework-dev,
                libtiff5-dev,
                orthanc-dev (>= 1.1.0),
                uuid-dev,
                yui-compressor,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-wsi
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-wsi.git
 Homepage: http://www.orthanc-server.com/static.php?page=wsi
@@ -27,6 +24,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Built-Using: ${orthancframework:Built-Using}
 Recommends: orthanc (>= 1.1.0),
             libopenslide0
 Description: Whole-slide imaging support for Orthanc (digital pathology)

=== debian/rules ===
--- 
+++ 
@@ -14,27 +14,33 @@
 %:
 	dh $@
 
+ORTHANC_FRAMEWORK_LIBRARIES="boost_filesystem boost_iostreams boost_locale boost_regex boost_thread jsoncpp pugixml uuid  dcmdata ofstd jpeg png curl boost_program_options dcmjpeg dcmjpls dcmimage dl"
+
 CMAKE_APPLICATIONS_EXTRA_FLAGS += \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
+	-DORTHANC_FRAMEWORK_SOURCE=system \
+        -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
+        -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
 	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
 
 CMAKE_VIEWER_EXTRA_FLAGS += \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
+	-DORTHANC_FRAMEWORK_SOURCE=system \
+        -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
+        -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
 	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
 	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.min.css \
 	-DOPENLAYERS_JS=$(CURDIR)/BuildViewer/ol.min.js \
 	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
 
+# Automated generation of the "Built-Using" attribute in "d/control"
+# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=989126
+# Adapted from:
+# https://wiki.debian.org/SIMDEverywhere#Approach (Point 6)
+override_dh_gencontrol:
+	dh_gencontrol -- -Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)"
+
 override_dh_auto_configure:
-        # Put 3rd party packages where the cmake build system expects them
-	mkdir -p Applications/ThirdPartyDownloads
-	( cd Applications/ThirdPartyDownloads && \
-	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.7.0.tar.gz . )
-
-	mkdir -p ViewerPlugin/ThirdPartyDownloads
-	( cd ViewerPlugin/ThirdPartyDownloads && \
-	  ln -s ../../debian/ThirdPartyDownloads/Orthanc-1.7.0.tar.gz . )
-
         # Configure the command-line tools
 	mkdir BuildApplications
 	dh_auto_configure --builddirectory=BuildApplications \
@@ -62,12 +68,6 @@
 	dh_auto_build --builddirectory=BuildViewer \
 		      --sourcedirectory=ViewerPlugin
 
-override_dh_clean:
-	rm -rf Applications/ThirdPartyDownloads/
-	rm -rf ViewerPlugin/ThirdPartyDownloads/
-
-	dh_clean
-
 override_dh_auto_install:
         # Install the command-line tools
 	dh_auto_install --builddirectory=BuildApplications
